import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;


public class ComparePC {
	
	public static ArrayList<String> extraPCfromFiles(File f) {
		ArrayList<String> hm = new ArrayList<String>();
		try {
			BufferedReader br = new BufferedReader(new FileReader(f));
			String line = br.readLine();
			String pcstr = "";
			boolean skip = true;
			while (line!=null) {
				if (line.startsWith("(query")&&skip==true) {
					line = line.substring(8);
					skip = false;
				}
				if (skip==true) {
					line = br.readLine();
					continue;
				}
				pcstr = pcstr+" "+line.trim();
				if (line.endsWith("]"))
					skip = true;
				line = br.readLine();
			}
//			System.out.println(pcstr);
			String singlepred = "";
			int level = 0;
			for (int i=0;i<pcstr.length();i++) {
				if (pcstr.charAt(i)=='(')
					level++;
				if (level>=1)
					singlepred+=pcstr.charAt(i);
				if (pcstr.charAt(i)==')')
					level--;
				if (level==0) {
					if (singlepred.length()>0) {
						hm.add(singlepred.trim());
						singlepred = "";
					}
				}
			}
			br.close();

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
//		for (int i=0;i<hm.size();i++) 
//			System.out.println(hm.get(i));
		
		return hm;
	}
	
	public static HashMap<String,Integer> predicateMap;

	public static void main(String[] args) {
		if (args.length!=1) { 
			System.err.println("Please select a dir.");
			return;
		}
		String dir = args[0];
		File folder = new File(dir);
		if (!folder.exists()) {
			System.err.println("Folder does not exist.");
			return;
		}
			
		File[] listOfFiles = folder.listFiles();
		int totalpcnum = 0;
		predicateMap = new HashMap<String,Integer>();
		for (int i=0;i<listOfFiles.length;i++) {
			if (listOfFiles[i].isFile()) {
				String fn = listOfFiles[i].getName();
				if (fn.endsWith(".pc")) {
					ArrayList<String> pcset = extraPCfromFiles(listOfFiles[i]);
					totalpcnum++;
					for (int j=0;j<pcset.size();j++) {
						String curpred = pcset.get(j);
						if (predicateMap.containsKey(curpred)) {
							int occ = predicateMap.get(curpred);
							
							predicateMap.put(curpred,occ+1);						

							}
						else {
							predicateMap.put(curpred, 1);
						}
					}
					if (!pcset.contains("(Eq 33 (Read w8 11 arr2))"))
						System.out.println(fn);
		//			else 
		//				checknum++;
						
				}
			}
		}
		Object[] predicates = predicateMap.keySet().toArray();
		for (int i=0;i<predicates.length;i++) {
			int occurance = predicateMap.get(predicates[i]);
			if (occurance>totalpcnum-50)
				System.out.println(occurance+"\t"+predicates[i]);
		}
//		System.out.println(predicateMap.get("(Eq 91 (Read w8 0 U0))"));
	}
}
