import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashSet;


public class SimpleFilter {

	public static void main(String[] args) {
		if (args.length!=2) { 
			System.err.println("Please input two files.");
			return;
		}
		String file1 = args[0];
		String file2 = args[1];
		if (!(new File(file1)).exists()) {
			System.err.println("file1 does not exist.");
			return;
		}

		if (!(new File(file2)).exists()) {
			System.err.println("file2 does not exist.");
			return;
		}
		
		HashSet<String> comSet = new HashSet<String>();
		try {
			BufferedReader br = new BufferedReader(new FileReader(file2));
			String line = br.readLine();
			while (line!=null) {
				comSet.add(line.trim());
				line = br.readLine();
			}

			br.close();
			
			br = new BufferedReader(new FileReader(file1));
			line = br.readLine();
			while (line!=null) {
				line = line.trim();
				int index = line.indexOf("*");
				String loc = line.substring(0,index);
				if (comSet.contains(loc)) {
					System.out.println(line);
				}
				line = br.readLine();
			}

			br.close();
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
